% Figure4_1.m
% It requires the following functions:
% spTVTn.m
% fKeplerT.m
% fKeplerV.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial and final time, and  Time step
global h
t0=0;  tf=5000; 
t=[];erEnSVT=[];costSVT=[];
% Initial Conditions 
e=0.2;   
x0 = [1-e ; 0; 0; sqrt((1+e)/(1-e))];
q0=[x0(1); x0(2)];  p0=[x0(3); x0(4)]; 
% Energy at initial conditions
H0=((x0(3))^2+(x0(4))^2)/2-1/(sqrt((x0(1))^2+(x0(2))^2));

for i=1:2
   t=[];   x=[];  x1=[];   x2=[];  q2=[];  p2=[];  q2m=[];  p2m=[];
   N=4000*2^i;  h = (tf-t0)/N;
    [t q2 p2]=spVTVn(@fKeplerT,@fKeplerV,t0,tf,q0,p0,N);

 errorSVT=((p2(:,1)).^2+(p2(:,2)).^2)./2-...
     1./(sqrt((q2(:,1)).^2+(q2(:,2)).^2)) - H0;

  erEnSVT=[erEnSVT; max(abs(errorSVT))]; costSVT=[costSVT; 3*N];
  figure(2)
  hold on
   plot(log10(t),log10(errorSVT),'-k','LineWidth',1.5)
end

  axis([-0.5 3.5 -6 -1]) 
  annotation('doublearrow',[0.28,0.28],[0.33,0.64])
  text(0.3,-4,'O(h^6)','FontSize',14)
  annotation('doublearrow',[0.68,0.68],[0.38,0.76])
  text(2.4,-3,'O(h^9)','FontSize',14)

  xlabel('{\fontsize{14} log_{10}(t) }')   
  ylabel('{\fontsize{14} log_{10}(Err. En.)}')   
  box

