%             spVTVn.m
% Second order TVT-Splitting method
% fT, fV: the vectorfields
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t q p] = spVTVn(fT,fV,t0,tf,q0,p0,N)
 h = (tf-t0)/N;
  s=6;
a1=0.245298957184271;
a2=0.604872665711080;
a=[a1,a2,1/2-(a1+a2),1/2-(a1+a2),a2,a1];
b1=0.08298440641740515;
b2=0.396309801498368;
b3=-0.03905630492234859;
b=[b1,b2,b3,1-2*(b1+b2+b3),b3,b2,b1];

s=3;
ga1=1/(2-2^(1/3)); ga2=1-2*ga1;
b1=ga1/2;
a1=ga1;
b2=(ga1+ga2)/2;
a2=ga2;
b3=b2;
a3=a1;
b4=b1;
a=[a1,a2,a1];
b=[b1,b2,b2,b1];


ah=h*a; bh=h*b;
ah2=h*a/2; bh2=h*b/2;
 t=t0:h:tf;  q=q0';q1=q0; p=p0'; p1=p0;
 fV0 = fV(q1);
 for i=1:N;
     h2=h/2; q4=q1;p4=p1;
     for j=1:2
        p4 = p4 - h2*b(1)*fV(q4);
        for j=1:s;
            q4 = q4 + ah2(j)*fT(p4);
            fV0 = fV(q4);
            p4 = p4 - bh2(j+1)*fV0;
        end
     end
      q2=q1;p2=p1;
        p2 = p2 - h*b(1)*fV(q2);
    for j=1:s;
     q2= q2 + ah(j)*fT(p2);
     fV0 = fV(q2);
     p2 = p2 - bh(j+1)*fV0;
    end
    q1=(16*q4-q2)/15;
    p1=(16*p4-p2)/15;
   q = [q ; q1' ];
   p = [p ; p1' ];
 end
end
